<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Bulto StructType
 * @subpackage Structs
 */
class Bulto extends AbstractStructBase
{
    /**
     * The alto
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $alto;
    /**
     * The ancho
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ancho;
    /**
     * The codBultoCli
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codBultoCli;
    /**
     * The codUnico
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codUnico;
    /**
     * The descripcion
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $descripcion;
    /**
     * The kilos
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kilos;
    /**
     * The largo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $largo;
    /**
     * The observaciones
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $observaciones;
    /**
     * The orden
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $orden;
    /**
     * The referencia
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $referencia;
    /**
     * The volumen
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $volumen;
    /**
     * Constructor method for Bulto
     * @uses Bulto::setAlto()
     * @uses Bulto::setAncho()
     * @uses Bulto::setCodBultoCli()
     * @uses Bulto::setCodUnico()
     * @uses Bulto::setDescripcion()
     * @uses Bulto::setKilos()
     * @uses Bulto::setLargo()
     * @uses Bulto::setObservaciones()
     * @uses Bulto::setOrden()
     * @uses Bulto::setReferencia()
     * @uses Bulto::setVolumen()
     * @param string $alto
     * @param string $ancho
     * @param string $codBultoCli
     * @param string $codUnico
     * @param string $descripcion
     * @param string $kilos
     * @param string $largo
     * @param string $observaciones
     * @param string $orden
     * @param string $referencia
     * @param string $volumen
     */
    public function __construct($alto = null, $ancho = null, $codBultoCli = null, $codUnico = null, $descripcion = null, $kilos = null, $largo = null, $observaciones = null, $orden = null, $referencia = null, $volumen = null)
    {
        $this
            ->setAlto($alto)
            ->setAncho($ancho)
            ->setCodBultoCli($codBultoCli)
            ->setCodUnico($codUnico)
            ->setDescripcion($descripcion)
            ->setKilos($kilos)
            ->setLargo($largo)
            ->setObservaciones($observaciones)
            ->setOrden($orden)
            ->setReferencia($referencia)
            ->setVolumen($volumen);
    }
    /**
     * Get alto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAlto()
    {
        return isset($this->alto) ? $this->alto : null;
    }
    /**
     * Set alto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $alto
     * @return \StructType\Bulto
     */
    public function setAlto($alto = null)
    {
        // validation for constraint: string
        if (!is_null($alto) && !is_string($alto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($alto)), __LINE__);
        }
        if (is_null($alto) || (is_array($alto) && empty($alto))) {
            unset($this->alto);
        } else {
            $this->alto = $alto;
        }
        return $this;
    }
    /**
     * Get ancho value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAncho()
    {
        return isset($this->ancho) ? $this->ancho : null;
    }
    /**
     * Set ancho value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ancho
     * @return \StructType\Bulto
     */
    public function setAncho($ancho = null)
    {
        // validation for constraint: string
        if (!is_null($ancho) && !is_string($ancho)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ancho)), __LINE__);
        }
        if (is_null($ancho) || (is_array($ancho) && empty($ancho))) {
            unset($this->ancho);
        } else {
            $this->ancho = $ancho;
        }
        return $this;
    }
    /**
     * Get codBultoCli value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodBultoCli()
    {
        return isset($this->codBultoCli) ? $this->codBultoCli : null;
    }
    /**
     * Set codBultoCli value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codBultoCli
     * @return \StructType\Bulto
     */
    public function setCodBultoCli($codBultoCli = null)
    {
        // validation for constraint: string
        if (!is_null($codBultoCli) && !is_string($codBultoCli)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codBultoCli)), __LINE__);
        }
        if (is_null($codBultoCli) || (is_array($codBultoCli) && empty($codBultoCli))) {
            unset($this->codBultoCli);
        } else {
            $this->codBultoCli = $codBultoCli;
        }
        return $this;
    }
    /**
     * Get codUnico value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodUnico()
    {
        return isset($this->codUnico) ? $this->codUnico : null;
    }
    /**
     * Set codUnico value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codUnico
     * @return \StructType\Bulto
     */
    public function setCodUnico($codUnico = null)
    {
        // validation for constraint: string
        if (!is_null($codUnico) && !is_string($codUnico)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codUnico)), __LINE__);
        }
        if (is_null($codUnico) || (is_array($codUnico) && empty($codUnico))) {
            unset($this->codUnico);
        } else {
            $this->codUnico = $codUnico;
        }
        return $this;
    }
    /**
     * Get descripcion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescripcion()
    {
        return isset($this->descripcion) ? $this->descripcion : null;
    }
    /**
     * Set descripcion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descripcion
     * @return \StructType\Bulto
     */
    public function setDescripcion($descripcion = null)
    {
        // validation for constraint: string
        if (!is_null($descripcion) && !is_string($descripcion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($descripcion)), __LINE__);
        }
        if (is_null($descripcion) || (is_array($descripcion) && empty($descripcion))) {
            unset($this->descripcion);
        } else {
            $this->descripcion = $descripcion;
        }
        return $this;
    }
    /**
     * Get kilos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKilos()
    {
        return isset($this->kilos) ? $this->kilos : null;
    }
    /**
     * Set kilos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kilos
     * @return \StructType\Bulto
     */
    public function setKilos($kilos = null)
    {
        // validation for constraint: string
        if (!is_null($kilos) && !is_string($kilos)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kilos)), __LINE__);
        }
        if (is_null($kilos) || (is_array($kilos) && empty($kilos))) {
            unset($this->kilos);
        } else {
            $this->kilos = $kilos;
        }
        return $this;
    }
    /**
     * Get largo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLargo()
    {
        return isset($this->largo) ? $this->largo : null;
    }
    /**
     * Set largo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $largo
     * @return \StructType\Bulto
     */
    public function setLargo($largo = null)
    {
        // validation for constraint: string
        if (!is_null($largo) && !is_string($largo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($largo)), __LINE__);
        }
        if (is_null($largo) || (is_array($largo) && empty($largo))) {
            unset($this->largo);
        } else {
            $this->largo = $largo;
        }
        return $this;
    }
    /**
     * Get observaciones value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getObservaciones()
    {
        return isset($this->observaciones) ? $this->observaciones : null;
    }
    /**
     * Set observaciones value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $observaciones
     * @return \StructType\Bulto
     */
    public function setObservaciones($observaciones = null)
    {
        // validation for constraint: string
        if (!is_null($observaciones) && !is_string($observaciones)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($observaciones)), __LINE__);
        }
        if (is_null($observaciones) || (is_array($observaciones) && empty($observaciones))) {
            unset($this->observaciones);
        } else {
            $this->observaciones = $observaciones;
        }
        return $this;
    }
    /**
     * Get orden value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrden()
    {
        return isset($this->orden) ? $this->orden : null;
    }
    /**
     * Set orden value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $orden
     * @return \StructType\Bulto
     */
    public function setOrden($orden = null)
    {
        // validation for constraint: string
        if (!is_null($orden) && !is_string($orden)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orden)), __LINE__);
        }
        if (is_null($orden) || (is_array($orden) && empty($orden))) {
            unset($this->orden);
        } else {
            $this->orden = $orden;
        }
        return $this;
    }
    /**
     * Get referencia value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReferencia()
    {
        return isset($this->referencia) ? $this->referencia : null;
    }
    /**
     * Set referencia value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $referencia
     * @return \StructType\Bulto
     */
    public function setReferencia($referencia = null)
    {
        // validation for constraint: string
        if (!is_null($referencia) && !is_string($referencia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($referencia)), __LINE__);
        }
        if (is_null($referencia) || (is_array($referencia) && empty($referencia))) {
            unset($this->referencia);
        } else {
            $this->referencia = $referencia;
        }
        return $this;
    }
    /**
     * Get volumen value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVolumen()
    {
        return isset($this->volumen) ? $this->volumen : null;
    }
    /**
     * Set volumen value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $volumen
     * @return \StructType\Bulto
     */
    public function setVolumen($volumen = null)
    {
        // validation for constraint: string
        if (!is_null($volumen) && !is_string($volumen)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($volumen)), __LINE__);
        }
        if (is_null($volumen) || (is_array($volumen) && empty($volumen))) {
            unset($this->volumen);
        } else {
            $this->volumen = $volumen;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Bulto
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
